import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';

part 'global.g.dart';

enum Platform { Twitter, Steem }

enum ApplicationRoute {
  Home,
  Settings,
  Help,
  Transaction,
  SteemBinding,
  TwitterBinding,
  Backup
}

@JsonSerializable()
class Global extends Equatable {
  @JsonKey(name: 'show_wallet_was_created')
  final bool walletWasCreated;

  @JsonKey(name: 'show_wallet_was_imported')
  final bool walletWasImported;

  @JsonKey(name: 'has_backed_up_wallet')
  final bool hasBackedUpWallet;

  @JsonKey(name: 'has_run_before')
  final bool hasRunBefore;

  @JsonKey(name: 'last_screen')
  final ApplicationRoute lastRoute;

  Global(
      {walletWasCreated,
      walletWasImported,
      hasBackedUpWallet,
      hasRunBefore,
      lastRoute})
      : this.walletWasCreated = walletWasCreated ?? false,
        this.walletWasImported = walletWasImported ?? false,
        this.hasBackedUpWallet = hasBackedUpWallet ?? false,
        this.hasRunBefore = hasRunBefore ?? false,
        this.lastRoute = lastRoute,
        super();

  Global.initialState()
      : walletWasCreated = false,
        walletWasImported = false,
        hasBackedUpWallet = false,
        hasRunBefore = false,
        lastRoute = null;

  Global copyWith({
    bool walletWasCreated,
    bool walletWasImported,
    bool hasBackedUpWallet,
    bool hasRunBefore,
    ApplicationRoute lastRoute,
  }) {
    return Global(
      walletWasCreated: walletWasCreated ?? this.walletWasCreated,
      walletWasImported: walletWasImported ?? this.walletWasImported,
      hasBackedUpWallet: hasBackedUpWallet ?? this.hasBackedUpWallet,
      hasRunBefore: hasRunBefore ?? this.hasRunBefore,
      lastRoute: lastRoute ?? this.lastRoute,
    );
  }

  factory Global.fromJson(Map<String, dynamic> json) => _$GlobalFromJson(json);

  Map<String, dynamic> toJson() => _$GlobalToJson(this);

  @override
  String toString() => this.toJson().toString();
}
