import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';
import 'package:snaxdart_models/v1.dart';
import 'package:snaxdart_errors/snaxdart_errors.dart';

part 'transfer.g.dart';

@JsonSerializable()
class Transfer extends Equatable {
  @JsonKey(name: 'data')
  final WalletTransaction data;

  @JsonKey(name: 'loading')
  final bool loading;

  @JsonKey(name: 'error')
  final SnaxError error;

  Transfer({this.data, this.loading, this.error});

  Transfer.initialState()
      : data = null,
        loading = false,
        error = null;

  Transfer copyWith({
    WalletTransaction data,
    bool loading,
    SnaxError error,
  }) {
    return Transfer(
      data: data ?? this.data,
      loading: loading ?? this.loading,
      error: error ?? this.error,
    );
  }

  factory Transfer.fromJson(Map<String, dynamic> json) =>
      _$TransferFromJson(json);

  Map<String, dynamic> toJson() => _$TransferToJson(this);

  @override
  String toString() => this.toJson().toString();
}
